Skip to content

Credits from a transaction without reference

Request

POST {{baseURL}}/pay-api/v1/transactions/return/no-reference

This endpoint refunds or returns funds without a reference.

Without a reference means the customer does not have the link to the original transaction identifier. This creates a refund transaction that is not linked to a specific previous transaction. Instead of refunding a known transaction identifier, the system processes a standalone credit back to the cardholder's payment method.

The endpoint requires the administrative API permission: Ecommerce Refund Without Reference.

See Also:
To refund using a transaction identifier, see POST /pay-api/v1/transactions/return
To settle a transaction, see POST /pay-api/v1/transactions/settle

Security
Bearer
Bodyapplication/json
cardDataSourceinteger, (int32)required

Specifies the card data source.

Possible values:

ValueNameDescription
1InternetVirtual Terminal, ISV API
2SwipeTrack1, Track2
3NFCEMV Tags, Track2
4EMVEMV Tags
5EMVContactlessEMV Tags
6FallbackSwipeTrack 2
7ManualCard present keyed transaction

Example: 2

Example:2
currencyIdinteger, (int32)required

Specifies the Flute currency identifier.

Always set to 1.

Example: 1

Example:1
debitbooleanrequired

Specifies the card as a debit card.

If true, the card as a debit card.
If false, the card as a credit card.

Example: true

Example:true
paymentProcessorIdstring, (uuid)required

Specifies the identifier assigned to the payment processor.

Example: 0c16d6e5-6157-42f0-a285-d14abbc54faa

Example:"0c16d6e5-6157-42f0-a285-d14abbc54faa"
customerIdstring or null, (uuid)

Specifies the customer identifier.

This is used when saving the payment method.
If this value is provided, the payment method is saved to the specified customer.
If this value is not provided, a new customer record is created.

Example: fd9198a4-eb6f-4620-9603-4f4638289de5

Example:"fd9198a4-eb6f-4620-9603-4f4638289de5"
amountnumber, (double)

The amount of the transaction.

accountNumberstring or null

The 13-19 digit card number used for the transaction.

This field may contain a token issued against a card number. This is de-tokenized by TransIT to process the transaction.

Example: 5413591081013511 example: "5413591081013511"

securityCodestring or null

The three or four digit security code on the credit card.

expirationMonthinteger or null, (int32)

Specifies the expiration month of the card.

Example: 7

Example:7
expirationYearinteger or null, (int32)

Specifies the expiration year of the card.

Example: 2032

Example:2032
track1string or null

Magnetic track 1.

track2string or null

Magnetic track 2.

emvTagsArray of strings or null

Holds data fetched from a EMV Chip Credit/Debit card to perform transaction. That is a string array of variable size, should be used as is.

emvPaymentAppVersionstring or null

The version number of the payment application in use.

billingAddressobject

Specifies an object defining the address.

shippingAddressobject

Specifies an object defining the address.

contactInfoobject

This group contains the customer's contact details.

pinstring or null

Encrypted PIN for the terminal.

pinKsnstring or null

The KSN for DUKPT PIN encryption. Required only if the PIN is encrypted using DUKPT.

emvFallbackConditioninteger, (int32)

Possible values:

ValueName
0ICCTerminalError
1NoCandidateList

Example: 2

Example:2
emvFallbackLastChipReadinteger, (int32)

Possible values:

ValueName
0Successful
1Failed
2NotAChipTransaction
3Unknown

Example: 1

Example:1
referenceIdstring or null

Specifies an external transaction identifier for client-side tracking.

Also used in duplicate control validation. A unique value allows similar transactions to process as distinct, bypassing duplicate blocking when needed.

curl -i -X POST \
  https://developer.flute.com/_mock/api-reference/pay-api/v1/transactions/return/no-reference \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "paymentProcessorId": "64aa4643-2c62-45fa-9554-3a69833114e9",
    "customerId": null,
    "amount": 10.1,
    "currencyId": 1,
    "accountNumber": null,
    "securityCode": null,
    "expirationMonth": 12,
    "expirationYear": 2032,
    "track1": "B5413330056003511^CUST IMP MC 351/^2512101000000000",
    "track2": null,
    "emvTags": null,
    "emvPaymentAppVersion": null,
    "cardDataSource": 2,
    "billingAddress": {},
    "shippingAddress": {},
    "contactInfo": null,
    "pin": "1111",
    "pinKsn": "2222222222",
    "debit": false,
    "emvFallbackCondition": null,
    "emvFallbackLastChipRead": null,
    "referenceId": "123456"
  }'

Responses

OK

Bodyapplication/json
transactionIdstring, (uuid)

Identifies the transaction identifier.

Example: c7c15dd0-03e7-4e55-917c-54bedafba5e7

Example:"c7c15dd0-03e7-4e55-917c-54bedafba5e7"
transactionDateTimestring, (date-time)

Specifies the date and time (in an ISO 8601 date-time UTC format) of the transaction execution.

Examples: 2026-02-19T20:24:52.934Z

Example:"2026-02-19T20:24:52.934Z"
typeIdinteger, (int32)

Type id of transaction.

typestring or null

Type name of transaction

statusIdinteger, (int32)

Indicates the status identifier of the transaction.

statusstring or null

Indicates the status name of the transaction

detailsobject
transactionReceiptobject or null


Indicates an object describing the transaction receipt. The transaction receipt will be null or empty before the transaction is completed. After the completed transaction, it be filled out.

processedAmountnumber, (double)

Indicates which amount is authorized. The amount may differ from the amount in the request.

avsResponseobject

Address Verification Service Response

Response
{ "processedAmount": 10, "avsResponse": { "actionId": 1, "action": "Allow", "responseCode": "0", "groupId": 5, "group": "ValidGroup", "resultId": 1, "result": "Passed", "codeDescription": "The street address and ZIP Code match the information on file." }, "transactionReceipt": { "transactionId": "b8c9d0e1-f2a3-4b4c-5d6e-7f8a9b0c1d47", "transactionDateTime": "2026-12-16T10:35:52.000000Z", "amount": { "baseAmount": 0, "percentageOffAmount": 0, "percentageOffRate": 0, "cashDiscountAmount": 0, "cashDiscountRate": 0, "surchargeAmount": 0, "surchargeRate": 0, "tipAmount": 0, "tipRate": 0, "totalAmount": 0 }, "currencyId": 1, "currency": "USD", "processorId": "e5f6a7b8-c9d0-4e1f-2a3b-4c5d6e7f8a14", "processor": "TSYS", "operationTypeId": 0, "operationType": null, "paymentMethodTypeId": 0, "paymentMethodType": null, "transactionTypeId": 0, "transactionType": null, "customerId": null, "customerPan": null, "cardTokenType": 1, "statusId": 0, "status": null, "merchantName": null, "merchantAddress": null, "merchantPhoneNumber": null, "merchantEmailAddress": null, "merchantWebsite": null, "authCode": null, "source": null, "cardholderAuthenticationMethodId": null, "cardholderAuthenticationMethod": null, "cvmResultMsg": null, "cardDataSourceId": null, "cardDataSource": null, "responseCode": null, "responseDescription": null, "cardProcessingDetails": { "authCode": "A0000", "mid": null, "tid": null, "cardCreditDebitTypeId": 2, "cardCreditDebitType": "Debit", "processCreditDebitTypeId": 1, "processCreditDebitType": "Credit", "rrn": "10628361287F", "cardTypeId": 0, "cardType": null }, "achProcessingDetails": { "customerAccountNumber": null, "customerRoutingNumber": null, "accountHolderType": null, "accountHolderTypeId": 0, "accountType": null, "accountTypeId": 0, "taxId": null }, "availableOperations": [ { "typeId": 4, "type": "Void", "availableAmount": null, "suggestedTips": null }, { "typeId": 8, "type": "TipAdjustment", "availableAmount": null, "suggestedTips": [ { "tipPercent": 5, "tipAmount": 10 }, { "tipPercent": 10, "tipAmount": 20 }, { "tipPercent": 15, "tipAmount": 30 } ] } ], "avsResponse": { "actionId": 1, "action": "Allow", "responseCode": null, "groupId": 5, "group": "ValidGroup", "resultId": 1, "result": "Passed", "codeDescription": null }, "emvTags": { "ac": "533C2902770EA987", "tvr": "0040040000", "tsi": null, "aid": "A0000000031010", "applicationLabel": "MasterCard", "rawTags": [ { "key": "5F34", "value": "SOMETHING" }, { "key": "5F35", "value": "SOMETHING" } ] }, "orderNumber": "752314" }, "transactionId": "e5f6a7b8-c9d0-4e1f-2a3b-4c5d6e7f8a14", "transactionDateTime": "2025-12-16T10:35:52.4617311Z", "typeId": 1, "type": "Authorization", "statusId": 1, "status": "Authorized", "details": { "hostResponseCode": "00", "hostResponseMessage": "APPROVAL", "hostResponseDefinition": "Approved and completed", "code": "Approve", "message": "Success", "processorResponseCode": null, "authCode": "VTLMC1", "maskedPan": null } }